.\" Copyright (c) 1990, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)ctermid.3	5.2 (Berkeley) 4/19/91
.\"	$NetBSD: cuserid.3,v 1.11 2003/08/07 16:44:17 agc Exp $
.\"
.Dd November 28, 1993
.Dt CUSERID 3
.Os
.Sh NAME
.Nm cuserid
.Nd get user name
.Sh LIBRARY
.Lb libcompat
.Sh SYNOPSIS
.In stdio.h
.Ft char *
.Fn cuserid "char *buf"
.Sh DESCRIPTION
.Bf -symbolic
This interface is available from the compatibility library, libcompat and
has been obsoleted by
.Xr getlogin 2 .
.Ef
.Pp
The
.Fn cuserid
function returns a character string representation of the user name
associated with the effective user ID of the calling process.
.Pp
If
.Fa buf
is not the
.Dv NULL
pointer, the user name is copied into the memory referenced by
.Fa buf .
The argument
.Fa buf
is assumed to point to an array at least
.Dv L_cuserid
(as defined in the include
file
.Aq Pa stdio.h )
bytes long.
Otherwise, the user name is copied to a static buffer.
.Sh RETURN VALUES
If
.Fa buf
is not the
.Dv NULL
pointer,
.Fa buf
is returned;
otherwise the address of the static buffer is returned.
.Pp
If the user name could not be determined, if
.Fa buf
is not the
.Dv NULL
pointer, the null character
.Sq \e0
will be stored at
.Fa *buf ;
otherwise
the
.Dv NULL
pointer is returned.
.Sh SEE ALSO
.Xr getlogin 2 ,
.Xr getpwent 3
.Sh STANDARDS
The
.Fn cuserid
function conforms to
.St -p1003.1-88 .
.Sh BUGS
Due to irreconcilable differences in historic implementations,
.Fn cuserid
was removed from the
.St -p1003.1-90
standard.
This implementation exists purely for compatibility with existing programs.
New programs should use one of the following three alternatives to
obtain the user name:
.Pp
.Bl -enum -offset indent -compact
.It
.Fn getlogin
to return the user's login name.
.It
.Nm getpwuid Ns Pq Fn geteuid
to return the user name associated with the calling process' effective user ID.
.It
.Nm getpwuid Ns Pq Fn getuid
to return the user name associated with the calling process' real user ID.
.El
